#include <signal.h>

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>

std::FILE *in, *out;

void write_user(int x) { std::fprintf(in, "%d\n", x); }

void write_user(int x, int y) { std::fprintf(in, "%d %d\n", x, y); }

void wrong(const int num) {
  std::fprintf(stderr, "translate:wrong\n");
  std::fprintf(stderr, "Wrong Answer [%d]\n", num);
  if (num == 0) std::fprintf(stderr, "wrong format from stub.\n");
  std::fprintf(stdout, "0.00\n");
  std::exit(0);
}

void ok() {
  std::fprintf(stderr, "translate:success\n");
  std::fprintf(stderr, "Accepted\n");
  std::fprintf(stdout, "1.00\n");
  std::exit(0);
}

long long read_user() {
  std::fflush(in);
  long long x;
  if (std::fscanf(out, "%lld", &x) != 1) wrong(0);
  return x;
}

long long read_in() {
  long long x;
  if (std::scanf("%lld", &x) != 1) {
    std::fprintf(stderr, "input file is broken\n");
    std::exit(1);
  }
  return x;
}

int main(int argc, char** argv) {
  if (argc != 3) {
    fprintf(stderr, "Usage: %s <u-to-m> <m-to-u>\n", argv[0]);
    return 1;
  }

  signal(SIGPIPE, SIG_IGN);
  out = std::fopen(argv[1], "r");
  in = std::fopen(argv[2], "w");

  // init

  const int N = read_in();

  std::vector<int> F(N);
  for (int& f : F) f = read_in();

  std::vector<std::pair<int, int>> edge(N - 1);
  for (auto& [U, V] : edge) {
    U = read_in();
    V = read_in();
  }

  const int Q = read_in();
  std::vector<std::pair<int, int>> query(Q);
  for (auto& [X, Y] : query) {
    X = read_in();
    Y = read_in();
  }

  write_user(N);
  for (int i = 0; i < N; i++) fprintf(in, "%d%c", F[i], " \n"[i + 1 == N]);
  for (auto [U, V] : edge) write_user(U, V);
  write_user(Q);

  bool wa = false;
  auto num_tours = [&] {
    if (read_user() != read_in()) wa = true;
  };
  num_tours();

  for (int i = 0; i < Q; i++) {
    write_user(query[i].first, query[i].second);
    num_tours();
  }

  if (wa)
    wrong(1);
  else
    ok();
}
