#include <csignal>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <utility>

#include "joitour.h"

int main(int argc, char** argv) {
  if (argc != 3) {
    std::fprintf(stderr, "Usage: %s <m-to-u> <u-to-m>\n", argv[0]);
    return 1;
  }
  // open pipe
  std::signal(SIGPIPE, SIG_IGN);
  FILE* out = std::fopen(argv[2], "w");
  FILE* in = std::fopen(argv[1], "r");

  auto read = [&] {
    int x;
    if (std::fscanf(in, "%d", &x) != 1) {
      std::fprintf(stderr, "data not sent from manager.\n");
      std::exit(1);
    }
    return x;
  };

  auto num_tours = [&] {
    const long long ans = ::num_tours();
    std::fprintf(out, "%lld\n", ans);
    std::fflush(out);
  };

  const int N = read();
  std::vector<int> F(N), U(N - 1), V(N - 1);
  for (int i = 0; i < N; i++) F[i] = read();
  for (int i = 0; i < N - 1; i++) {
    U[i] = read();
    V[i] = read();
  }

  const int Q = read();

  init(N, F, U, V, Q);
  num_tours();

  for (int i = 0; i < Q; i++) {
    const int X = read(), Y = read();
    change(X, Y);
    num_tours();
  }
}
